<?php

namespace Drupal\asana\Plugin\Block;

use Drupal\Core\Block\BlockBase;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
use Drupal\asana\Asana;

/**
 * Provides the Asana Projects block.
 *
 * @Block(
 *   id = "asana_projects",
 *   admin_label = @Translation("Asana Projects"),
 *   category = @Translation("Asana")
 * )
 */
class AsanaProjects extends BlockBase implements ContainerFactoryPluginInterface {

  /**
   * Drupal\asana\AsanaCore definition.
   *
   * @var Drupal\asana\AsanaCore
   */
  protected $asanaCore;

  /**
   * {@inheritdoc}
   */
  public function __construct(array $configuration, $plugin_id, $plugin_definition, Asana $asana) {
    parent::__construct($configuration, $plugin_id, $plugin_definition);
    $this->asana = $asana;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container, array $configuration, $plugin_id, $plugin_definition) {
    return new static(
      $configuration, $plugin_id, $plugin_definition, $container->get('asana')
    );
  }

  /**
   * {@inheritdoc}
   */
  public function build() {
    $build['asana_projects'] = [
      '#theme' => 'item_list',
      '#items' => $this->asana->getAllProjects(),
    ];

    return $build;
  }

}
